/////////////////////////////////////////
//  OtBbNteXgvO   //
//  2016/3/2  SG12864  glcdlib2.c      //
//  PIC18F452  MPLAB v8.92  C18 v3.47  //
/////////////////////////////////////////
#include "global.h"

/////////   Zbg
void  lcg_reset(void){
    RST = 0;
    delay_ms(50);
    RST = 1, E = 0;
    CS1 = CS2 = 1;
}

/////////   ZbgAbv
void t_setup(void){
    Delay1TCY();        //NOP
    Delay1TCY();        //NOP
    Delay1TCY();        //NOP
    Delay1TCY();        //NOP
}

/////////   Xe[^X[h
//          F\ubN
//          ߂lFXe[^X
uchar lcg_status(uchar cs){
    uchar ret;

    TRISD = 0xff;           //DATA IN
    if(cs == 1){
        CS1 = 0;
         CS2 = 1;
    }
    if(cs == 2){
            CS2 = 0;
        CS1 = 1;
    }
    RW = 1;
    DI = 0;
    Delay1TCY();            //NOP
    E = 1;
    t_setup();
    ret = DB;
    E = 0;
    CS1 = 1;
    CS2 = 1;
    return ret;
}

/////////   BUSY WAIT
void lcg_busy(void){
    while(lcg_status(2) & 0x80);
    while(lcg_status(1) & 0x80);
}

/////////   \̃IIt
//            PF\AOF
void lcg_disp(uchar disp){
    lcg_busy();
    TRISD = 0;              //DATA OUT
    CS1 = 0;
    CS2 = 1;
    RW = 0;
    DI = 0;
    if(disp) DB = 0x3f;
    else DB = 0x3e;
    E = 1;
    t_setup();
    E = 0;
    CS1 = 1;
    lcg_busy();
    TRISD = 0;              //DATA OUT
    CS2 = 0;
    CS1 = 1;
    RW = 0;
    DI = 0;
    if(disp) DB = 0x3f;
    else DB = 0x3e;
    E = 1;
    t_setup();
    E = 0;
    CS2 = 1;
}

/////////   \JnC̃Zbgiʏ͂Ô܂܁j
//          FJnCiO`URj
void lcg_sline(uchar line){
    lcg_busy();
    TRISD = 0;              //DATA OUT
    CS1 = 0;
    CS2 = 1;
    RW = 0;
    DI = 0;
    line |= 0xc0;           //R[hƃC
    DB = line;
    E = 1;
    t_setup();
    E = 0;
    CS1 = 1;
    lcg_busy();
    TRISD = 0;              //DATA OUT
    CS2 = 0, CS1 = 1;
    RW = 0, DI = 0;
    line |= 0xc0;           //R[hƃC
    DB = line;
    E = 1;
    t_setup();
    E = 0;
    CS2 = 1;
}

/////////   wAhX̃Zbg
//          FsAhXiO`VjA\ubN
void lcg_xaddr(uchar addr, uchar cs){
    lcg_busy();
    TRISD = 0;              //DATA OUT
    if(cs == 1){
         CS1 = 0;
         CS2 = 1;
    }
    if(cs == 2) {
        CS2 = 0;
        CS1 = 1;
    }
    RW = 0;
    DI = 0;
    addr |= 0xb8;           //R[hƃC
    DB = addr;
    E = 1;
    t_setup();
    E = 0;
    CS2 = 1;
    CS1 = 1;
}

/////////   xAhX̃Zbg
//          FAhXiO`URjA\ubN
void lcg_yaddr(uchar addr, uchar cs){
    lcg_busy();
    TRISD = 0;              //DATA OUT
    if(cs == 1){
        CS1 = 0;
        CS2 = 1;
    }
    if(cs == 2){
        CS2 = 0;
        CS1 = 1;
    }
    RW = 0;
    DI = 0;
    addr |= 0x40;           //R[hƃC
    DB = addr;
    E = 1;
    t_setup();
    E = 0;
    CS2 = 1;
    CS1 = 1;
}

/////////   f[^̏
//          Fރf[^
void lcg_write(uchar data, uchar cs){
    lcg_busy();
    TRISD = 0;              //DATA OUT
    if(cs == 1){
            CS1 = 0;
        CS2 = 1;
    }
    if(cs == 2){
        CS2 = 0;
        CS1 = 1;
    }
    RW = 0;
    DI = 1;
    DB = data;
    E = 1;
    t_setup();
    E = 0;
    CS2 = 1;
    CS1 = 1;
}

/////////   f[^̓ǂݍ
//          FǂݍރubN
//          ߂lFǂݍ񂾃f[^
uchar lcg_read(uchar cs){
    uchar ret;

    lcg_busy();
    TRISD = 0xff;               //DATA IN
    if(cs == 1){
        CS1 = 0;
        CS2 = 1;
    }
    if(cs == 2){
        CS2 = 0;
        CS1 = 1;
    }
    DI= 1;
    RW = 1;
    Delay1TCY();                //NOP
    E = 1;
    t_setup();
    ret = DB;
    E = 0;
    CS2 = 1;
    CS1 = 1;
    return ret;
}

/////////   W~WtHg̏
//          FsiO`VjAiO`PTjAtHgԍ
void lcg_char(uchar line, uchar colum, uchar num){
    uchar i, csn;

    if(line > 7) return;
    if(colum > 15) return;
    if(colum > 7) {
        colum -= 8;
        csn = 1;
    }
    else csn = 2;
    lcg_xaddr(line, csn); lcg_yaddr(colum * 8, csn);
    for(i = 0; i < 8; i++){
        lcg_write(Font8[num][i], csn);
    }
}

////////    W~W̕\
//          FJnsiO`VjAJniO`PTjAւ̃|C^
void lcg_str(uchar line, uchar colum,  rom const char* str){
    char c, n;

    while((c = *str) != '\0'){
        lcg_char(line, colum, c);
        str++;
        colum++;
        if(colum > 15){
            colum -= 16;
            line ++;
            if(line > 7) return;
        }
    }
}

/////////   PU~PUtHg̏
//          FJnsiO`RjAJniO`VjAtHgԍ
void lcg_font16(uchar line, uchar colum, uchar num){
    uchar i, csn;

    if(line > 3)return;
    if(colum > 7) return;
    if(colum > 3){
        colum -= 4;
        csn = 1;
    }
    else csn = 2;
    lcg_xaddr(line * 2, csn); lcg_yaddr(colum * 16, csn);
    for(i = 0; i < 16; i++){
        lcg_write(Font16[num][i], csn);
    }
    lcg_xaddr(line * 2 + 1, csn); lcg_yaddr(colum * 16, csn);
    for(i = 16; i < 32; i++){
        lcg_write(Font16[num][i], csn);
    }
}

/////////   \S
void lcg_clear(void){
    uchar i, j, csn;
    
    lcg_disp(0);
    csn = 1;
    for(i = 0; i < 8; i++){
        for(j = 0; j < 64; j++){
            lcg_xaddr(i, csn);
            lcg_yaddr(j, csn);
            lcg_write(0, csn);
        }
    }
    csn = 2;
    for(i = 0; i < 8; i++){
        for(j = 0; j < 64; j++){
            lcg_xaddr(i, csn);
            lcg_yaddr(j, csn);
            lcg_write(0, csn);
        }
    }
    lcg_disp(1);
}

//////// W~WLN^Q{Ɋg
//       FsiO`RjAiO`VjAtHgԍ
void lcg_font8x2(uchar li, uchar col, uchar num){
    uchar i, j, c, csn;
    uchar f_buff[32] = {0,0,0,0,0,0,0,0,
                        0,0,0,0,0,0,0,0,
                        0,0,0,0,0,0,0,0,
                        0,0,0,0,0,0,0,0};

    if(li > 3)return;
    if(col > 7) return;
    for(i = 0; i < 5; i++){
        c = Font8[num][i];
        if(c & 0x1) f_buff[2 * i] = f_buff[2 * i +1] = 0x3;
        if(c & 0x2) f_buff[2 * i] = f_buff[2 * i +1] |= 0xc;
        if(c & 0x4) f_buff[2 * i] = f_buff[2 * i +1] |= 0x30;
        if(c & 0x8) f_buff[2 * i] = f_buff[2 * i +1] |= 0xc0;
        if(c & 0x10) f_buff[2 * i + 16] = f_buff[2 * i +17] = 0x3;
        if(c & 0x20) f_buff[2 * i + 16] = f_buff[2 * i +17] |= 0xc;
        if(c & 0x40) f_buff[2 * i + 16] = f_buff[2 * i +17] |= 0x30;
    }
    lcg_busy();
    if(col > 3){
        col -= 4;
        csn = 1;
    }
    else csn = 2;
    lcg_xaddr(li * 2, csn); lcg_yaddr(col * 16, csn);
    for(i = 0; i < 16; i++){
        lcg_write(f_buff[i], csn);
    }
    lcg_xaddr(li * 2 + 1, csn); lcg_yaddr(col * 16, csn);
    for(i = 16; i < 32; i++){
        lcg_write(f_buff[i], csn);
    }

}

///////// _ł
//        jxWxAhXAyWwAhX
//        FxWiO`PQVjAyWiO`URjAIIt
void lcg_pset(uchar x, uchar y, uchar flg){
    uchar temp, n, c, xx, yy, csn;

    if(x > 127)return;
    if(y > 63) return;    
    if(x > 63){
        x -= 64;
        csn = 1;
    }
    else csn = 2;
    xx = y / 8;                             //\̂wAhX͏c
    temp = y % 8;
    n = 0x1;
    n = n << temp;
    yy = x;                                 //\̂xAhX͉
    lcg_xaddr(xx, csn);lcg_yaddr(yy, csn);
    c = lcg_read(csn);                      //ǂ
    c = lcg_read(csn);
    if(flg){
        c |= n;
    }
    else {
        n = ~n;
        c &= n;
    }
    lcg_xaddr(xx, csn);lcg_yaddr(yy, csn);
    lcg_write(c, csn);
}

/////////   Βl
int abs(int a){
    if(a < 0) a = -a;
    return a;
}

/////////   
//          Fn_xWAn_yWAI_xWAI_yWAIIt
void lcg_line(int x0, int y0, int x1, int y1, uchar c){
    int slant, tmp;
    int dx, dy, error;
    int x, y;
    int ystep;
    
    slant = (abs(y1 - y0) > abs(x1 - x0));
    if(slant){
        tmp = x0; x0 = y0; y0 = tmp;
        tmp = x1; x1 = y1; y1 = tmp;
    }
    if(x0 > x1) {
        tmp = x0; x0 = x1; x1 = tmp;
        tmp = y0; y0 = y1; y1 = tmp;
    }
    dx = x1 - x0;
    dy = abs(y1 - y0);
    error = 0;
    y = y0;
    if(y0 < y1) ystep = 1; else ystep = -1;
    for(x=x0; x<x1; x++) {
        if(slant) lcg_pset(y,x,c); else lcg_pset(x,y,c);
        error += dy;
        if((error << 1) >= dx) {
            y += ystep;
            error -= dx;
        }
    }
}

/////////   ~`
//          FSxWAŜWAaAIIt
void lcg_circle(int x, int y, int r, uchar c){
    int dx = r, dy = 0, s = r;

    while(dx >= dy){
        lcg_pset(x + dx, y + dy, c);lcg_pset(x + dx, y - dy, c);
        lcg_pset(x - dx, y + dy, c);lcg_pset(x - dx, y - dy, c);
        lcg_pset(x + dy, y + dx, c);lcg_pset(x + dy, y - dx, c);
        lcg_pset(x - dy, y + dx, c);lcg_pset(x - dy, y - dx, c);
        s -= 2 * dy + 1; 
        if(s < 0){
            s += 2 * (dx - 1);
             dx--;
        }
        dy++;
    }
}

/////////   ʕ\
void lcg_image(rom const char *iaddr){
    uchar i, j, csn;
    uint n;
    
    n = 0;
    for(i = 0; i < 8; i++){
        for(j = 0; j < 128; j++){
            if(j > 63){
                csn = 1;
                lcg_xaddr(i, csn);
                lcg_yaddr(j - 64, csn);
            }
            else {
                csn = 2;
                lcg_xaddr(i, csn);
                lcg_yaddr(j, csn);
            }
            lcg_write(iaddr[n], csn);
            n++;
        }
    }
}

/////////   ʓhԂ
void lcg_paint(void){
    uchar i, j, csn;
       
    for(i = 0; i < 8; i++){
        for(j = 0; j < 128; j++){
            if(j > 63){
                csn = 1;
                lcg_xaddr(i, csn);
                lcg_yaddr(j - 64, csn);
            }
            else {
                csn = 2;
                lcg_xaddr(i, csn);
                lcg_yaddr(j, csn);
            }
            lcg_write(0xff, csn);
        }
    }
}
